/**************************************************************************
**   Copyright (C): 2018
**   Author: Navid MAHMOUDIAN BIDGOLI <navid.mahmoudian-bidgoli@inria.fr>
**   Inria research institute
**************************************************************************/
#include "openglhandler.h"
#include <iostream>

const char *vertexShader360Video =
"        #version 420 core                                                                                      \n"
"        layout (location = 0) in vec3 aPos;                                                                    \n"
"                                                                                                               \n"
"        out vec3 planePoints;                                                                                  \n"
"                                                                                                               \n"
"        uniform mat4 view;                                                                                     \n"
"        uniform mat4 projection;                                                                               \n"
"                                                                                                               \n"
"        void main()                                                                                            \n"
"        {                                                                                                      \n"
"                gl_Position = projection * view *  vec4(aPos, 1.0);                                            \n"
"                planePoints = aPos;                                                                            \n"
"        }                                                                                                      \n";

const char *fragmentShader360Video =
"        #version 420 core                                                                                                      \n"
"        ///#extension GL_ARB_shader_image_load_store : enable                                                                  \n"
"        const float pi = 3.141592653589793;                                                                                    \n"
"        varying vec3 planePoints;                                                                                              \n"
"        uniform sampler2D tex;                                                                                                 \n"
"        layout(binding = 3, r8) writeonly uniform image2D maskImage;    // put 3 just to show that it can be any number        \n"
"        uniform bool computeMask;                                                                                              \n"
"        layout(location = 0) out vec4 FragColor;                                                                               \n"
//"        const float halfpi = 0.5 * pi;"
//"float fmod (float x, float y)\n"
//"{\n"
//"  return x - y * trunc(x/y);\n"
//"}\n"
"        void main()                                                                                                            \n"
"        {                                                                                                                      \n"
"            vec2 equirectangularTexturePos;                                                                                    \n"
"            // planePoints are fragment points of a plane between zNear and zFar plane covering whole camera frustum.          \n"
"            // Since camera -Z direction always passes projection plane center,  each fragment world coordinate                \n"
"            // corresponds to a viewing ray. Since sphere has radius one, the normalized coordinate corresponds to             \n"
"            // the position/intersection on the unit sphere                                                                    \n"
"            vec3 spherepos = normalize(planePoints);                                                                           \n"
"            equirectangularTexturePos.x = (atan(spherepos.y, -spherepos.x)+pi)/(2.0*pi);                                       \n"
"            equirectangularTexturePos.y = 1.f - acos(spherepos.z)/(pi);                                                        \n"
//"            equirectangularTexturePos.y = 1.f - fmod(acos(spherepos.z)+halfpi, pi)/(pi);                                                        \n"
"                                                                                                                               \n"
"            if(computeMask)                                                                                                    \n"
"            {                                                                                                                  \n"
"                // When we use GL_LINEAR as filtering function and TEXTURE_WRAP is REPEAT. according to                        \n"
"                // (page 150 of https://www.khronos.org/registry/OpenGL/specs/gl/glspec13.pdf), four                           \n"
"                // nearest texels are used for sampling:                                                                       \n"
"                                                                                                                               \n"
"                // Floating point texel coordinate into the upscaled texture.                                                  \n"
"                ivec2 sizeTex_lev0 = textureSize(tex, 0);                                                                      \n"
"                vec2 ptu = equirectangularTexturePos * sizeTex_lev0;                                                           \n"
"                // Decompose ptu - 0.5 into the integer and fractional parts.                                                  \n"
"        ///        vec2 ptui;                                                                                                  \n"
"        ///        vec2 ptuf = modf(ptu - 0.5, ptui);                                                                          \n"
"                                                                                                                               \n"
"                // Integer texel coordinates into the upscaled texture.                                                        \n"
"                ivec2 ptu00 = ivec2(ptu - 0.5);                                                                                \n"
"                ivec2 ptu01 = ptu00 + ivec2(0, 1);                                                                             \n"
"                ivec2 ptu10 = ptu00 + ivec2(1, 0);                                                                             \n"
"                ivec2 ptu11 = ptu00 + ivec2(1, 1);                                                                             \n"
"                                                                                                                               \n"
"                // Integer texel coordinates into the original texture.                                                        \n"
"                ivec2 pt00 = clamp(ptu00 , ivec2(0), sizeTex_lev0 - 1);                                                        \n"
"                ivec2 pt01 = clamp(ptu01 , ivec2(0), sizeTex_lev0 - 1);                                                        \n"
"                ivec2 pt10 = clamp(ptu10 , ivec2(0), sizeTex_lev0 - 1);                                                        \n"
"                ivec2 pt11 = clamp(ptu11 , ivec2(0), sizeTex_lev0 - 1);                                                        \n"
"                                                                                                                               \n"
"                imageStore(maskImage, pt00, vec4(1.0, 0.0, 0.0, 0.0));                                                         \n"
"                imageStore(maskImage, pt01, vec4(1.0, 0.0, 0.0, 0.0));                                                         \n"
"                imageStore(maskImage, pt10, vec4(1.0, 0.0, 0.0, 0.0));                                                         \n"
"                imageStore(maskImage, pt11, vec4(1.0, 0.0, 0.0, 0.0));                                                         \n"
"            }                                                                                                                  \n"
"            FragColor = texture2D(tex, equirectangularTexturePos);                                                             \n"
"                                                                                                                               \n"
"        }                                                                                                                      \n";


const char *vertexShader360CubeMap =
"        #version 420 core                                              \n"
"        layout (location = 0) in vec3 aPos;                            \n"

"        out vec3 TexCoords;                                            \n"
"        uniform mat4 projection;                                       \n"
"        uniform mat4 view;                                             \n"

"        void main()                                                    \n"
"        {                                                              \n"
"            TexCoords = aPos;                                          \n"
"            vec4 pos = projection * view * vec4(aPos, 1.0);            \n"
"            gl_Position = pos.xyww;                                    \n"
"        }                                                              \n";

const char *fragmentShader360CubeMap =
"        #version 420 core                                                                                                              \n"

"        in vec3 TexCoords;                                                                                                             \n"
"        uniform samplerCube cubeMapTex;                                                                                                \n"
"        layout(binding = 3, r8) writeonly uniform imageCube maskImage;    // put 3 just to show that it can be any number              \n"
"        uniform bool computeMask;                                                                                                      \n"
"        layout(location = 0) out vec4 FragColor;                                                                                       \n"

"        vec2 sampleCube( const vec3 v, out int faceIndex)                                                                              \n"
"        {                                                                                                                              \n"
"                vec3 vAbs = abs(v);                                                                                                    \n"
"                float ma;                                                                                                              \n"
"                vec2 uv;                                                                                                               \n"
"                if(vAbs.z >= vAbs.x && vAbs.z >= vAbs.y)                                                                               \n"
"                {                                                                                                                      \n"
"                        faceIndex = v.z < 0.0 ? 5 : 4;                                                                                 \n"
"                        ma = 0.5 / vAbs.z;                                                                                             \n"
"                        uv = vec2(v.z < 0.0 ? -v.x : v.x, -v.y);                                                                       \n"
"                }                                                                                                                      \n"
"                else if(vAbs.y >= vAbs.x)                                                                                              \n"
"                {                                                                                                                      \n"
"                        faceIndex = v.y < 0.0 ? 3 : 2;                                                                                 \n"
"                        ma = 0.5 / vAbs.y;                                                                                             \n"
"                        uv = vec2(v.x, v.y < 0.0 ? -v.z : v.z);                                                                        \n"
"                }                                                                                                                      \n"
"                else                                                                                                                   \n"
"                {                                                                                                                      \n"
"                        faceIndex = v.x < 0.0 ? 1 : 0;                                                                                 \n"
"                        ma = 0.5 / vAbs.x;                                                                                             \n"
"                        uv = vec2(v.x < 0.0 ? v.z : -v.z, -v.y);                                                                       \n"
"                }                                                                                                                      \n"
"                return uv * ma + 0.5;                                                                                                  \n"
"        }                                                                                                                              \n"

"        void main()                                                                                                                    \n"
"        {                                                                                                                              \n"
"            vec3 TexCoords_new;                                                                                                        \n"

"        // order of cube map in opengl:                                                                                                \n"
"        // +X (right)                                                                                                                  \n"
"        // -X (left)                                                                                                                   \n"
"        // +Y (top)                                                                                                                    \n"
"        // -Y (bottom)                                                                                                                 \n"
"        // +Z (front)                                                                                                                  \n"
"        // -Z (back)                                                                                                                   \n"

"            // we need to change the order to be aligned with our coordinate system                                                    \n"
"            TexCoords_new.z = TexCoords.y;                                                                                             \n"
"            TexCoords_new.x = TexCoords.x;                                                                                             \n"
"            TexCoords_new.y = -TexCoords.z;                                                                                            \n"
"            if(computeMask)                                                                                                            \n"
"            {                                                                                                                          \n"
"                int faceIndex;                                                                                                         \n"
"                vec2 p = sampleCube(TexCoords_new, faceIndex);                                                                         \n"

"                // Floating point texel coordinate into the upscaled texture.                                                          \n"
"                ivec2 sizeTex_lev0 = textureSize(cubeMapTex, 0);                                                                       \n"
"                vec2 ptu = p * sizeTex_lev0;                                                                                           \n"

"                // Integer texel coordinates into the upscaled texture.                                                                \n"
"                ivec2 ptu00 = ivec2(ptu - 0.5);                                                                                        \n"
"                ivec2 ptu01 = ptu00 + ivec2(0, 1);                                                                                     \n"
"                ivec2 ptu10 = ptu00 + ivec2(1, 0);                                                                                     \n"
"                ivec2 ptu11 = ptu00 + ivec2(1, 1);                                                                                     \n"

"                // Integer texel coordinates into the original texture.                                                                \n"
"                ivec2 pt00 = clamp(ptu00 , ivec2(0), sizeTex_lev0 - 1);                                                                \n"
"                ivec2 pt01 = clamp(ptu01 , ivec2(0), sizeTex_lev0 - 1);                                                                \n"
"                ivec2 pt10 = clamp(ptu10 , ivec2(0), sizeTex_lev0 - 1);                                                                \n"
"                ivec2 pt11 = clamp(ptu11 , ivec2(0), sizeTex_lev0 - 1);                                                                \n"

"                imageStore(maskImage, ivec3(pt00, faceIndex), vec4(1.0, 0.0, 0.0, 0.0));                                               \n"
"                imageStore(maskImage, ivec3(pt01, faceIndex), vec4(1.0, 0.0, 0.0, 0.0));                                               \n"
"                imageStore(maskImage, ivec3(pt10, faceIndex), vec4(1.0, 0.0, 0.0, 0.0));                                               \n"
"                imageStore(maskImage, ivec3(pt11, faceIndex), vec4(1.0, 0.0, 0.0, 0.0));                                               \n"


"            }                                                                                                                          \n"
"            FragColor = texture(cubeMapTex, TexCoords_new);                                                                            \n"
"        }                                                                                                                              \n";

const char* fragmentShader360Healpix =
        "#version 430 core\n"
        "///#extension GL_ARB_shader_image_load_store : enable\n"
        "const double pi=3.141592653589793238462643383279502884197;\n"
        "const double twopi=6.283185307179586476925286766559005768394;\n"
        "const double twothird=2.0/3.0;\n"
        "const double inv_halfpi=0.6366197723675813430755350534900574;\n"
        "const double halfpi = 0.5 * pi;\n"
        "const double root3 = sqrt(3.0);\n"
        "varying vec3 planePoints;\n"
        "layout(binding = 3, r8) writeonly uniform image2D maskImage;    // put 3 just to show that it can be any number\n"
        "uniform bool computeMask;\n"
        "layout(location = 0) out vec4 FragColor;\n"
        "uniform bool isNest;\n"
        "uniform int healpixOrder;\n"
        "uniform int equi_width;\n"
        "uniform int equi_height;\n"
        "layout(binding = 4, rgba8) readonly uniform image2DArray healpixFaceTexture;    // put 3 just to show that it can be any number\n"
        "\n"
        "const uint utab[] = {\n"
        "#define Z(a) 0x##a##0, 0x##a##1, 0x##a##4, 0x##a##5\n"
        "#define Y(a) Z(a##0), Z(a##1), Z(a##4), Z(a##5)\n"
        "#define X(a) Y(a##0), Y(a##1), Y(a##4), Y(a##5)\n"
        "X(0),X(1),X(4),X(5)\n"
        "#undef X\n"
        "#undef Y\n"
        "#undef Z\n"
        "};\n"
        "\n"
        "const uint ctab[] = {\n"
        "#define Z(a) a,a+1,a+256,a+257\n"
        "#define Y(a) Z(a),Z(a+2),Z(a+512),Z(a+514)\n"
        "#define X(a) Y(a),Y(a+4),Y(a+1024),Y(a+1028)\n"
        "X(0),X(8),X(2048),X(2056)\n"
        "#undef X\n"
        "#undef Y\n"
        "#undef Z\n"
        "};\n"
        "\n"
        "const int jrll[] = { 2,2,2,2,3,3,3,3,4,4,4,4 };\n"
        "const int jpll[] = { 1,3,5,7,0,2,4,6,1,3,5,7 };\n"
        "\n"
        "int spread_bits (int v) { return int(utab[v&0xff]) | (int(utab[(v>>8)&0xff])<<16); }\n"
        "\n"
        "int compress_bits (int v)\n"
        "{\n"
        "  int raw = (v&0x5555) | ((v&0x55550000)>>15);\n"
        "  return int(ctab[raw&0xff]) | (int(ctab[raw>>8])<<4);\n"
        "}\n"
        "\n"
        "int xyf2nest(int order_, int ix, int iy, int face_num)\n"
        "  { return (int(face_num)<<(2*order_)) + spread_bits(ix) + (spread_bits(iy)<<1); }\n"
        "\n"
        "// low-level hack to accelerate divisions with a result of [0;3]\n"
        "int special_div(int a, int b)\n"
        "{\n"
        "    int t=int(a>=(b<<1));\n"
        "    a-= t*(b<<1);\n"
        "    return (t<<1)+int(a>=b);\n"
        "}\n"
        "\n"
        "uint isqrt (int arg) { return uint(sqrt(double(arg)+0.5));}\n"
        "\n"
        "void ring2xyf (int order_, int pix, out int ix, out int iy, out int face_num)\n"
        "{\n"
        "    int nside_  = int(1)<<order_;\n"
        "    int npface_ = nside_<<order_;\n"
        "    int ncap_   = int(npface_-nside_)<<1;\n"
        "    int npix_ = 12 * npface_;\n"
        "    int iring, iphi, kshift, nr;\n"
        "    int nl2 = 2*nside_;\n"
        "\n"
        "    if (pix<ncap_) // North Polar cap\n"
        "    {\n"
        "        iring = (1+int(isqrt(1+2*pix)))>>1; //counted from North pole\n"
        "        iphi  = (pix+1) - 2*iring*(iring-1);\n"
        "        kshift = 0;\n"
        "        nr = iring;\n"
        "        face_num=special_div(iphi-1,nr);\n"
        "    }\n"
        "    else if (pix<(npix_-ncap_)) // Equatorial region\n"
        "    {\n"
        "        int ip = pix - ncap_;\n"
        "        int tmp = (order_>=0) ? ip>>(order_+2) : ip/(4*nside_);\n"
        "        iring = tmp+nside_;\n"
        "        iphi = ip-tmp*4*nside_ + 1;\n"
        "        kshift = (iring+nside_)&1;\n"
        "        nr = nside_;\n"
        "        int ire = tmp+1,\n"
        "        irm = nl2+1-tmp;\n"
        "        int ifm = iphi - (ire>>1) + nside_ -1,\n"
        "            ifp = iphi - (irm>>1) + nside_ -1;\n"
        "        if (order_>=0)\n"
        "        { ifm >>= order_; ifp >>= order_; }\n"
        "        else\n"
        "        { ifm /= nside_; ifp /= nside_; }\n"
        "        face_num = (ifp==ifm) ? (ifp|4) : ((ifp<ifm) ? ifp : (ifm+8));\n"
        "    }\n"
        "    else // South Polar cap\n"
        "    {\n"
        "        int ip = npix_ - pix;\n"
        "        iring = (1+int(isqrt(2*ip-1)))>>1; //counted from South pole\n"
        "        iphi  = 4*iring + 1 - (ip - 2*iring*(iring-1));\n"
        "        kshift = 0;\n"
        "        nr = iring;\n"
        "        iring = 2*nl2-iring;\n"
        "        face_num=special_div(iphi-1,nr)+8;\n"
        "    }\n"
        "    int irt = iring - ((2+(face_num>>2))*nside_) + 1;\n"
        "    int ipt = 2*iphi- jpll[face_num]*nr - kshift -1;\n"
        "    //  I ipt = 2*iphi- (((face_num&3)<<1)+1-((face_num>>2)&1))*nr - kshift -1;\n"
        "    if (ipt>=nl2) ipt-=8*nside_;\n"
        "\n"
        "    ix =  (ipt-irt) >>1;\n"
        "    iy = (-ipt-irt) >>1;\n"
        "}\n"
        "\n"
        "double safe_atan2 (double y, double x)\n"
        "{\n"
        "  return ((x==0.) && (y==0.)) ? double(0.0) : double(atan(float(y),float(x)));\n"
        "}\n"
        "\n"
        "\n"
        "void nest2xyf (int order_, int pix, out int ix, out int iy, out int face_num)\n"
        "{\n"
        "  int nside_  = int(1)<<order_;\n"
        "  int npface_ = nside_<<order_;\n"
        "  face_num = pix>>(2*order_);\n"
        "  pix &= (npface_-1);\n"
        "  ix = compress_bits(pix);\n"
        "  iy = compress_bits(pix>>1);\n"
        "}\n"
        "\n"
        "double fmod (double x, double y)\n"
        "{\n"
        "  return x - y * trunc(x/y);\n"
        "}\n"
        "\n"
        "double fmodulo (double v1, double v2)\n"
        "{\n"
        "  if (v1>=0)\n"
        "    return (v1<v2) ? v1 : fmod(v1,v2);\n"
        "  double tmp=fmod(v1,v2)+v2;\n"
        "  return (tmp==v2) ? 0. : tmp;\n"
        "//  return (v1>=0) ? ((v1<v2) ? v1 : fmod(v1,v2)) : (fmod(v1,v2)+v2);\n"
        "}\n"
        "\n"
        "int loc2pix (int order_, bool is_nest, double z, double phi, double sth, bool have_sth)\n"
        "{\n"
        "  int nside_  = int(1)<<order_;\n"
        "  int npface_ = nside_<<order_;\n"
        "  int ncap_   = int(npface_-nside_)<<1;\n"
        "  int npix_ = 12 * npface_;\n"
        "  double za = abs(z);\n"
        "  double tt = fmodulo(phi*inv_halfpi,4.0); // in [0,4)\n"
        "///  double tt = mod(phi*inv_halfpi,4.0); // in [0,4)\n"
        "\n"
        "  if (!is_nest)\n"
        "  {\n"
        "    if (za<=twothird) // Equatorial region\n"
        "      {\n"
        "      int nl4 = 4*nside_;\n"
        "      double temp1 = nside_*(0.5+tt);\n"
        "      double temp2 = nside_*z*0.75;\n"
        "      int jp = int(temp1-temp2); // index of  ascending edge line\n"
        "      int jm = int(temp1+temp2); // index of descending edge line\n"
        "\n"
        "      // ring number counted from z=2/3\n"
        "      int ir = nside_ + 1 + jp - jm; // in {1,2n+1}\n"
        "      int kshift = 1-(ir&1); // kshift=1 if ir even, 0 otherwise\n"
        "\n"
        "      int t1 = jp+jm-nside_+kshift+1+nl4+nl4;\n"
        "      int ip = (order_>0) ?\n"
        "        (t1>>1)&(nl4-1) : ((t1>>1)%nl4); // in {0,4n-1}\n"
        "\n"
        "      return ncap_ + (ir-1)*nl4 + ip;\n"
        "      }\n"
        "    else  // North & South polar caps\n"
        "      {\n"
        "      double tp = tt-int(tt);\n"
        "      double tmp = ((za<0.99)||(!have_sth)) ?\n"
        "                   nside_*sqrt(3*(1-za)) :\n"
        "                   nside_*sth/sqrt((1.+za)/3.);\n"
        "\n"
        "      int jp = int(tp*tmp); // increasing edge line index\n"
        "      int jm = int((1.0-tp)*tmp); // decreasing edge line index\n"
        "\n"
        "      int ir = jp+jm+1; // ring number counted from the closest pole\n"
        "      int ip = int(tt*ir); // in {0,4*ir-1}\n"
        "\n"
        "      //ip %= 4*ir;\n"
        "\n"
        "      return (z>0)  ?  2*ir*(ir-1) + ip  :  npix_ - 2*ir*(ir+1) + ip;\n"
        "      }\n"
        "  }\n"
        "  else // scheme_ == NEST\n"
        "    {\n"
        "    if (za<=twothird) // Equatorial region\n"
        "      {\n"
        "      double temp1 = nside_*(0.5+tt);\n"
        "      double temp2 = nside_*(z*0.75);\n"
        "      int jp = int(temp1-temp2); // index of  ascending edge line\n"
        "      int jm = int(temp1+temp2); // index of descending edge line\n"
        "      int ifp = jp >> order_;  // in {0,4}\n"
        "      int ifm = jm >> order_;\n"
        "      int face_num = (ifp==ifm) ? (ifp|4) : ((ifp<ifm) ? ifp : (ifm+8));\n"
        "\n"
        "      int ix = jm & (nside_-1),\n"
        "          iy = nside_ - (jp & (nside_-1)) - 1;\n"
        "      return xyf2nest(order_, ix,iy,face_num);\n"
        "      }\n"
        "    else // polar region, za > 2/3\n"
        "      {\n"
        "      int ntt = min(3,int(tt));\n"
        "      double tp = tt-ntt;\n"
        "      double tmp = ((za<0.99)||(!have_sth)) ?\n"
        "                   nside_*sqrt(3*(1-za)) :\n"
        "                   nside_*sth/sqrt((1.+za)/3.);\n"
        "\n"
        "      int jp = int(tp*tmp); // increasing edge line index\n"
        "      int jm = int((1.0-tp)*tmp); // decreasing edge line index\n"
        "      jp=min(jp,nside_-1); // for points too close to the boundary\n"
        "      jm=min(jm,nside_-1);\n"
        "      return (z>=0) ?\n"
        "        xyf2nest(order_, nside_-jm -1, nside_-jp-1, ntt) : xyf2nest(order_, jp, jm, ntt+8);\n"
        "      }\n"
        "    }\n"
        "}\n"
        "\n"
        "\n"
        "\n"
        "int vec2pix (int order_, bool is_nest, const vec3 vec)\n"
        "{\n"
        "  double xl = 1./sqrt(vec.x*vec.x + vec.y*vec.y + vec.z*vec.z);\n"
        "  double phi = safe_atan2(vec.y, vec.x);\n"
        "///  double phi = atan(vec.y, vec.x);\n"
        "  double nz = vec.z*xl;\n"
        "  if (abs(nz)>0.99)\n"
        "    return loc2pix (order_, is_nest, nz,phi,sqrt(vec.x*vec.x+vec.y*vec.y)*xl,true);\n"
        "  else\n"
        "    return loc2pix (order_, is_nest, nz,phi,0,false);\n"
        "}\n"
        "\n"
        "int ring2nest (int order_, int pix)\n"
        "{\n"
        "  int ix, iy, face_num;\n"
        "  ring2xyf (order_, pix, ix, iy, face_num);\n"
        "  return xyf2nest (order_, ix, iy, face_num);\n"
        "}\n"
        "\n"
        "\n"
        "int ring_above (int order_, double z)\n"
        "{\n"
        "  int nside_  = int(1)<<order_;\n"
        "  double az=abs(z);\n"
        "  if (az<=twothird) // equatorial region\n"
        "    return int(nside_*(2-1.5*z));\n"
        "  int iring = int(nside_*sqrt(3.*(1.-az)));\n"
        "  return (z>0) ? iring : 4*nside_-iring-1;\n"
        "}\n"
        "\n"
        "void get_ring_info2 (int order_, int ring, out int startpix, out int ringpix, out double theta, out bool shifted)\n"
        "{\n"
        "  int nside_  = int(1)<<order_;\n"
        "  int npface_ = nside_<<order_;\n"
        "  int ncap_   = (npface_-nside_)<<1;\n"
        "  int npix_   = 12*npface_;\n"
        "  double fact2_  = 4./npix_;\n"
        "  double fact1_  = (nside_<<1)*fact2_;\n"
        "\n"
        "  int northring = (ring>2*nside_) ? 4*nside_-ring : ring;\n"
        "  if (northring < nside_)\n"
        "  {\n"
        "    double tmp = northring*northring*fact2_;\n"
        "    double costheta = 1. - tmp;\n"
        "    double sintheta = sqrt(tmp*(2-tmp));\n"
        "    theta = atan(float(sintheta), float(costheta));\n"
        "    ringpix = 4*northring;\n"
        "    shifted = true;\n"
        "    startpix = 2*northring*(northring-1);\n"
        "  }\n"
        "  else\n"
        "  {\n"
        "    theta = acos(float(2*nside_-northring)*float(fact1_));\n"
        "    ringpix = 4*nside_;\n"
        "    shifted = ((northring-nside_) & 1) == 0;\n"
        "    startpix = ncap_ + (northring-nside_)*ringpix;\n"
        "  }\n"
        "  if (northring != ring) // southern hemisphere\n"
        "  {\n"
        "    theta = pi-theta;\n"
        "    startpix = npix_ - startpix - ringpix;\n"
        "  }\n"
        "}\n"
        "\n"
        "void get_interpol (int order_, bool is_nest, const vec3 position, out ivec4 pix, out dvec4 wgt)\n"
        "{\n"
        "  int nside_  = int(1)<<order_;\n"
        "  int npface_ = nside_<<order_;\n"
        "  int ncap_   = (npface_-nside_)<<1;\n"
        "  int npix_   = 12*npface_;\n"
        "\n"
        "///  double theta = atan(sqrt(position.x*position.x+position.y*position.y),position.z);\n"
        "///  double phi = safe_atan2(position.y,position.x);\n"
        "///  double z = cos(float(theta));\n"
        "\n"
        "  double theta = atan(sqrt(position.x*position.x+position.y*position.y),position.z);\n"
        "  double phi = atan(position.y, position.x);    // The above commented line provides holes in north and south pole\n"
        "  if(phi<0.) phi += twopi;\n"
        "  double z = position.z;\n"
        "\n"
        "  if((theta < 0.) || (theta > pi))  // normalize theta if needed\n"
        "  {\n"
        "    theta=fmodulo(theta,twopi);\n"
        "    if (theta>pi)\n"
        "    {\n"
        "      phi+=pi;\n"
        "      theta=twopi-theta;\n"
        "    }\n"
        "  }\n"
        "\n"
        "  if((phi < 0.) || (phi >= twopi))  // normalize phi if needed\n"
        "  {\n"
        "    phi=fmodulo(phi,twopi);\n"
        "  }\n"
        "\n"
        "  int ir1 = ring_above(order_, z);\n"
        "  int ir2 = ir1+1;\n"
        "  double theta1, theta2, w1, tmp, dphi;\n"
        "  int sp,nr;\n"
        "  bool shift;\n"
        "  int i1,i2;\n"
        "  if (ir1>0)\n"
        "  {\n"
        "    get_ring_info2 (order_, ir1, sp, nr, theta1, shift);\n"
        "    dphi = twopi/nr;\n"
        "    tmp = (phi/dphi - .5*double(shift));\n"
        "    i1 = (tmp<0) ? int(tmp)-1 : int(tmp);\n"
        "    w1 = (phi-(double(i1)+.5*double(shift))*dphi)/dphi;\n"
        "    i2 = i1+1;\n"
        "    if (i1<0) i1 +=nr;\n"
        "    if (i2>=nr) i2 -=nr;\n"
        "    pix[0] = sp+i1; pix[1] = sp+i2;\n"
        "    wgt[0] = 1-w1; wgt[1] = w1;\n"
        "  }\n"
        "  if (ir2<(4*nside_))\n"
        "  {\n"
        "    get_ring_info2 (order_, ir2, sp, nr, theta2, shift);\n"
        "    dphi = twopi/nr;\n"
        "    tmp = (phi/dphi - .5*double(shift));\n"
        "    i1 = (tmp<0) ? int(tmp)-1 : int(tmp);\n"
        "    w1 = (phi-(double(i1)+.5*double(shift))*dphi)/dphi;\n"
        "    i2 = i1+1;\n"
        "    if (i1<0) i1 +=nr;\n"
        "    if (i2>=nr) i2 -=nr;\n"
        "    pix[2] = sp+i1; pix[3] = sp+i2;\n"
        "    wgt[2] = 1-w1; wgt[3] = w1;\n"
        "  }\n"
        "\n"
        "  if (ir1==0)\n"
        "  {\n"
        "    double wtheta = theta/theta2;\n"
        "    wgt[2] *= wtheta; wgt[3] *= wtheta;\n"
        "    double fac = (1-wtheta)*0.25;\n"
        "    wgt[0] = fac; wgt[1] = fac; wgt[2] += fac; wgt[3] +=fac;\n"
        "    pix[0] = (pix[2]+2)&3;\n"
        "    pix[1] = (pix[3]+2)&3;\n"
        "  }\n"
        "  else if (ir2==4*nside_)\n"
        "  {\n"
        "    double wtheta = (theta-theta1)/(pi-theta1);\n"
        "    wgt[0] *= (1-wtheta); wgt[1] *= (1-wtheta);\n"
        "    double fac = wtheta*0.25;\n"
        "    wgt[0] += fac; wgt[1] += fac; wgt[2] = fac; wgt[3] =fac;\n"
        "    pix[2] = ((pix[0]+2)&3)+npix_-4;\n"
        "    pix[3] = ((pix[1]+2)&3)+npix_-4;\n"
        "  }\n"
        "  else\n"
        "  {\n"
        "    double wtheta = (theta-theta1)/(theta2-theta1);\n"
        "    wgt[0] *= (1-wtheta); wgt[1] *= (1-wtheta);\n"
        "    wgt[2] *= wtheta; wgt[3] *= wtheta;\n"
        "  }\n"
        "\n"
        "  if (is_nest)\n"
        "    for (int m=0; m<4; ++m)\n"
        "      pix[m] = ring2nest(order_, pix[m]);\n"
        "}\n"
        "\n"
        "void pix2loc (int order_, bool is_nest, int pix, out double z, out double phi, out double sth, out bool have_sth)\n"
        "{\n"
        "  int nside_  = int(1)<<order_;\n"
        "  int npface_ = nside_<<order_;\n"
        "  int ncap_   = (npface_-nside_)<<1;\n"
        "  int npix_   = 12*npface_;\n"
        "  double fact2_  = 4./npix_;\n"
        "  double fact1_  = (nside_<<1)*fact2_;\n"
        "\n"
        "  have_sth=false;\n"
        "\n"
        "  if (!is_nest)\n"
        "  {\n"
        "    if (pix<ncap_) // North Polar cap\n"
        "    {\n"
        "      int iring = (1+int(isqrt(1+2*pix)))>>1; // counted from North pole\n"
        "      int iphi  = (pix+1) - 2*iring*(iring-1);\n"
        "\n"
        "      double tmp=(iring*iring)*fact2_;\n"
        "      z = 1.0 - tmp;\n"
        "      if (z>0.99) { sth=sqrt(tmp*(2.-tmp)); have_sth=true; }\n"
        "      phi = (iphi-0.5) * halfpi/iring;\n"
        "    }\n"
        "    else if (pix<(npix_-ncap_)) // Equatorial region\n"
        "    {\n"
        "      int nl4 = 4*nside_;\n"
        "      int ip  = pix - ncap_;\n"
        "      int tmp = (order_>=0) ? ip>>(order_+2) : ip/nl4;\n"
        "      int iring = tmp + nside_;\n"
        "      int iphi = ip-nl4*tmp+1;\n"
        "      // 1 if iring+nside is odd, 1/2 otherwise\n"
        "      double fodd = bool((iring+nside_)&1) ? 1. : 0.5;\n"
        "\n"
        "      z = (2*nside_-iring)*fact1_;\n"
        "      phi = (iphi-fodd) * pi*0.75*fact1_;\n"
        "    }\n"
        "    else // South Polar cap\n"
        "    {\n"
        "      int ip = npix_ - pix;\n"
        "      int iring = (1+int(isqrt(2*ip-1)))>>1; // counted from South pole\n"
        "      int iphi  = 4*iring + 1 - (ip - 2*iring*(iring-1));\n"
        "\n"
        "      double tmp=(iring*iring)*fact2_;\n"
        "      z = tmp - 1.0;\n"
        "      if (z<-0.99) { sth=sqrt(tmp*(2.-tmp)); have_sth=true; }\n"
        "      phi = (iphi-0.5) * halfpi/iring;\n"
        "    }\n"
        "  }\n"
        "  else\n"
        "  {\n"
        "    int face_num, ix, iy;\n"
        "    nest2xyf(order_, pix,ix,iy,face_num);\n"
        "\n"
        "    int jr = (int(jrll[face_num])<<order_) - ix - iy - 1;\n"
        "\n"
        "    int nr;\n"
        "    if (jr<nside_)\n"
        "    {\n"
        "      nr = jr;\n"
        "      double tmp=(nr*nr)*fact2_;\n"
        "      z = 1 - tmp;\n"
        "      if (z>0.99) { sth=sqrt(tmp*(2.-tmp)); have_sth=true; }\n"
        "    }\n"
        "    else if (jr > 3*nside_)\n"
        "    {\n"
        "      nr = nside_*4-jr;\n"
        "      double tmp=(nr*nr)*fact2_;\n"
        "      z = tmp - 1;\n"
        "      if (z<-0.99) { sth=sqrt(tmp*(2.-tmp)); have_sth=true; }\n"
        "    }\n"
        "    else\n"
        "    {\n"
        "      nr = nside_;\n"
        "      z = (2*nside_-jr)*fact1_;\n"
        "    }\n"
        "\n"
        "    int tmp=int(jpll[face_num])*nr+ix-iy;\n"
        "    if (tmp<0) tmp+=8*nr;\n"
        "    phi = (nr==nside_) ? 0.75*halfpi*tmp*fact1_ :\n"
        "                         (0.5*halfpi*tmp)/nr;\n"
        "  }\n"
        "}\n"
        "\n"
        "void pix2ang (int order_, bool is_nest, int pix, out double theta, out double phi)\n"
        "{\n"
        "  double z, sth;\n"
        "  bool have_sth;\n"
        "  pix2loc (order_, is_nest, pix, z, phi, sth, have_sth);\n"
        "\n"
        "  double theta_have_sth = atan(float(sth),float(z));\n"
        "  theta = acos(float(z));\n"
        "  if(have_sth)\n"
        "    theta = theta_have_sth;\n"
        "\n"
        "\n"
        "///  if(have_sth)\n"
        "///    theta = atan(float(sth),float(z));\n"
        "///  else\n"
        "///    theta = acos(float(z));\n"
        "\n"
        "///  theta = (have_sth) ? atan(float(sth),float(z)) : acos(float(z));\n"
        "\n"
        "///  theta = (!have_sth) ? acos(float(z)) : atan(float(sth),float(z));\n"
        "\n"
        "///  if(!have_sth)\n"
        "///    theta = acos(float(z));\n"
        "///  else\n"
        "///    theta = atan(float(sth),float(z));\n"
        "\n"
        "}\n"
        "\n"
        "int ang2pix (int order_, bool is_nest, double theta, double phi)\n"
        "{\n"
        "  return ((theta<0.01) || (theta > 3.14159-0.01)) ?\n"
        "    loc2pix(order_, is_nest, cos(float(theta)), phi, sin(float(theta)),true) :\n"
        "    loc2pix(order_, is_nest, cos(float(theta)), phi, 0.,false);\n"
        "}\n"
        "\n"
        "int pix2ring (int order_, bool is_nest, int pix)\n"
        "{\n"
        "  int nside_  = int(1)<<order_;\n"
        "  int npface_ = nside_<<order_;\n"
        "  int ncap_   = (npface_-nside_)<<1;\n"
        "  int npix_   = 12*npface_;\n"
        "  if (!is_nest)\n"
        "  {\n"
        "    if (pix<ncap_) // North Polar cap\n"
        "      return (1+int(isqrt(1+2*pix)))>>1; // counted from North pole\n"
        "    else if (pix<(npix_-ncap_)) // Equatorial region\n"
        "      return (pix-ncap_)/(4*nside_) + nside_; // counted from North pole\n"
        "    else // South Polar cap\n"
        "      return 4*nside_-((1+int(isqrt(2*(npix_-pix)-1)))>>1);\n"
        "  }\n"
        "  else\n"
        "  {\n"
        "    int face_num, ix, iy;\n"
        "    nest2xyf(order_, pix,ix,iy,face_num);\n"
        "    return (int(jrll[face_num])<<order_) - ix - iy - 1;\n"
        "  }\n"
        "}\n"
        "\n"
        "void get_ring_info_small(int order_, int ring, out int startpix, out int ringpix, out bool shifted)\n"
        "{\n"
        " int nside_  = int(1)<<order_;\n"
        " int npface_ = nside_<<order_;\n"
        " int ncap_   = (npface_-nside_)<<1;\n"
        " int npix_   = 12*npface_;\n"
        "  if (ring < nside_)\n"
        "    {\n"
        "    shifted = true;\n"
        "    ringpix = 4*ring;\n"
        "    startpix = 2*ring*(ring-1);\n"
        "    }\n"
        "  else if (ring < 3*nside_)\n"
        "    {\n"
        "    shifted = ((ring-nside_) & 1) == 0;\n"
        "    ringpix = 4*nside_;\n"
        "    startpix = ncap_ + (ring-nside_)*ringpix;\n"
        "    }\n"
        "  else\n"
        "    {\n"
        "    shifted = true;\n"
        "    int nr= 4*nside_-ring;\n"
        "    ringpix = 4*nr;\n"
        "    startpix = npix_-2*nr*(nr+1);\n"
        "    }\n"
        "}\n"
        "\n"
        "void interpolate_weights(int order_, bool is_nest, const vec3 position, out ivec4 ring_indices, out dvec4 weights)\n"
        "{\n"
        "    int nside_  = int(1)<<order_;\n"
        "    int npface_ = nside_<<order_;\n"
        "    int ncap_   = (npface_-nside_)<<1;\n"
        "    int npix_   = 12*npface_;\n"
        "\n"
        "    bool tmp_is_ring = false;   // false means it is ring\n"
        "    double lat = atan(sqrt(position.x*position.x+position.y*position.y),position.z);\n"
        "    double lon = atan(position.y, position.x);    // The above commented line provides holes in north and south pole\n"
        "    if(lon<0.) lon += twopi;\n"
        "///    double z = position.z;\n"
        "\n"
        "    if((lat < 0.) || (lat > pi))  // normalize lat if needed\n"
        "    {\n"
        "      lat=fmodulo(lat,twopi);\n"
        "      if (lat>pi)\n"
        "      {\n"
        "        lon+=pi;\n"
        "        lat=twopi-lat;\n"
        "      }\n"
        "    }\n"
        "\n"
        "    if((lon < 0.) || (lon >= twopi))  // normalize lon if needed\n"
        "    {\n"
        "      lon=fmodulo(lon,twopi);\n"
        "    }\n"
        "\n"
        "    int ring1, ring2, ring3, ring4;\n"
        "    double lon1, lat1, lon2, lat2;\n"
        "    double lon3, lat3, lon4, lat4;\n"
        "    double xfrac1, xfrac2, yfrac, lon_frac;\n"
        "    int ring_number, longitude_index, n_in_ring;\n"
        "\n"
        "    // Find the index of the pixel in which the coordinates fall\n"
        "    ring1 = ang2pix (order_, tmp_is_ring, lat, lon);\n"
        "\n"
        "\n"
        "    if (ring1 < 0)\n"
        "    {\n"
        "        for (int i=0; i < 4; i++)\n"
        "        {\n"
        "            ring_indices[i] = 0;\n"
        "            weights[i] = 0.;\n"
        "        }\n"
        "        return;\n"
        "    }\n"
        "\n"
        "    // Find the lon/lat of the center of that pixel\n"
        "    pix2ang (order_, tmp_is_ring, ring1, lat1, lon1);\n"
        "\n"
        "    // Take into account possible wrapping so that the pixel longitude/latitude are close to the requested longitude/latitude\n"
        "    if (lon - lon1 > pi)\n"
        "        lon1 += twopi;\n"
        "    if (lon1 - lon > pi)\n"
        "        lon1 -= twopi;\n"
        "\n"
        "    ring_number = pix2ring ( order_, tmp_is_ring, ring1);\n"
        "    int start_pix_in_ring;\n"
        "    bool shifted;\n"
        "    get_ring_info_small(order_, ring_number, start_pix_in_ring, n_in_ring, shifted);\n"
        "    longitude_index = ring1 - start_pix_in_ring;\n"
        "\n"
        "    // We now want to find the next index in the ring so that the point to interpolate is between the two. First we check what direction to look in by finding the longitude/latitude of the center of the HEALPix pixel.\n"
        "\n"
        "    if (lon < lon1) { // Go to the left\n"
        "      if (longitude_index == 0) {\n"
        "        ring2 = ring1 + n_in_ring - 1;\n"
        "      } else {\n"
        "        ring2 = ring1 - 1;\n"
        "      }\n"
        "    } else { // Go to the right\n"
        "      if (longitude_index == n_in_ring - 1) {\n"
        "        ring2 = ring1 - n_in_ring + 1;\n"
        "      } else {\n"
        "        ring2 = ring1 + 1;\n"
        "      }\n"
        "    }\n"
        "\n"
        "\n"
        "    // Find the lon/lat of the new pixel\n"
        "    pix2ang (order_, tmp_is_ring, ring2, lat2, lon2);\n"
        "\n"
        "    // Take into account possible wrapping so that the pixel longitude/latitude are close to the requested longitude/latitude\n"
        "    if (lon - lon2 > pi)\n"
        "        lon2 += twopi;\n"
        "    if (lon2 - lon > pi)\n"
        "        lon2 -= twopi;\n"
        "\n"
        "    // Now check whether we are moving up or down in terms of ring index\n"
        "\n"
        "    if (lat <= lat1) { // Move up (0 index is at the top)\n"
        "        ring_number -= 1;\n"
        "    } else { // Move down\n"
        "        ring_number += 1;\n"
        "    }\n"
        "\n"
        "    double dphi;\n"
        "    if (ring_number > 0 && ring_number < 4 * nside_)\n"
        "    {\n"
        "        get_ring_info_small(order_, ring_number, start_pix_in_ring, n_in_ring, shifted);\n"
        "\n"
        "        // Now determine the longitude index in which the requested longitude falls.\n"
        "\n"
        "        // In all regions, the longitude elements are spaced by 360 / n_in_ring. For convenience we convert the longitude index so that the spacing is 1.\n"
        "        dphi = twopi / n_in_ring;\n"
        "        lon_frac = lon/dphi - .5*double(shifted);\n"
        "\n"
        "        // Find the longitude index of the closest pixel\n"
        "        longitude_index = (lon_frac<0) ? int(lon_frac)-1 : int(lon_frac);\n"
        "///        longitude_index = int(lon_frac);\n"
        "///        if (longitude_index == n_in_ring) {\n"
        "///          longitude_index -= 1;\n"
        "///        }\n"
        "        if (longitude_index<0) longitude_index +=n_in_ring;\n"
        "        if (longitude_index>=n_in_ring) longitude_index -=n_in_ring;\n"
        "\n"
        "        // Find the longitude/latitude and ring index of this pixel\n"
        "        ring3 = start_pix_in_ring + longitude_index;\n"
        "        pix2ang (order_, tmp_is_ring, ring3, lat3, lon3);\n"
        "\n"
        "        // Take into account possible wrapping so that the pixel longitude/latitude are close to the requested longitude/latitude\n"
        "        if (lon - lon3 > pi)\n"
        "            lon3 += twopi;\n"
        "        if (lon3 - lon > pi)\n"
        "            lon3 -= twopi;\n"
        "\n"
        "        // Finally we can find the fourth pixel as before\n"
        "        if (lon < lon3) { // Go to the left\n"
        "          if (longitude_index == 0) {\n"
        "            ring4 = ring3 + n_in_ring - 1;\n"
        "          } else {\n"
        "            ring4 = ring3 - 1;\n"
        "          }\n"
        "        } else { // Go to the right\n"
        "          if (longitude_index == n_in_ring - 1) {\n"
        "            ring4 = ring3 - n_in_ring + 1;\n"
        "          } else {\n"
        "            ring4 = ring3 + 1;\n"
        "          }\n"
        "        }\n"
        "\n"
        "        pix2ang (order_, tmp_is_ring, ring4, lat4, lon4);\n"
        "        // Take into account possible wrapping so that the pixel longitude/latitude\n"
        "        // are close to the requested longitude/latitude\n"
        "        if (lon - lon4 > pi)\n"
        "            lon4 += twopi;\n"
        "        if (lon4 - lon > pi)\n"
        "            lon4 -= twopi;\n"
        "\n"
        "        // Determine the interpolation weights\n"
        "\n"
        "        xfrac1 = (lon - lon1) / (lon2 - lon1);\n"
        "        xfrac2 = (lon - lon3) / (lon4 - lon3);\n"
        "        yfrac = (lat - lat1) / (lat3 - lat1);\n"
        "\n"
        "\n"
        "        weights[0] = (1. - xfrac1) * (1. - yfrac);\n"
        "        weights[1] = xfrac1 * (1. - yfrac);\n"
        "        weights[2] = (1. - xfrac2) * yfrac;\n"
        "        weights[3] = xfrac2 * yfrac;\n"
        "\n"
        "    }\n"
        "    else\n"
        "    {\n"
        "        // In the case where we are inside the four top/bottom-most\n"
        "        // values, we effectively place a value at the pole that\n"
        "        // is the average of the four values, and the interpolation\n"
        "        // is the weighted average of this polar value and the\n"
        "        // value interpolated along the ring.\n"
        "\n"
        "        xfrac1 = (lon - lon1) / (lon2 - lon1);\n"
        "        yfrac = (lat - lat1) / (halfpi - lat1);\n"
        "\n"
        "\n"
        "        if (ring_number == 0) {\n"
        "///          ring3 = (ring1 + 2) % 4;\n"
        "///          ring4 = (ring2 + 2) % 4;\n"
        "///          yfrac = (lat - lat1) / (halfpi - lat1);\n"
        "          ring3 = (ring1 + 2) & 3;\n"
        "          ring4 = (ring2 + 2) & 3;\n"
        "          yfrac = lat/lat1;\n"
        "          weights[0] = (1. - xfrac1) + 0.25 * (1. - yfrac);\n"
        "          weights[1] = xfrac1 + 0.25 * (1. - yfrac);\n"
        "\n"
        "        } else {\n"
        "///          ring3 = ((ring1 - (npix_ - 4)) + 2) % 4 + npix_ - 4;\n"
        "///          ring4 = ((ring2 - (npix_ - 4)) + 2) % 4 + npix_ - 4;\n"
        "///          yfrac = (lat - lat1) / (-halfpi - lat1);\n"
        "            ring3 = ((ring1 + 2) & 3) + npix_ - 4;\n"
        "            ring4 = ((ring2 + 2) & 3) + npix_ - 4;\n"
        "            yfrac = (lat - lat1) / (pi - lat1);\n"
        "            weights[0] = (1. - xfrac1) + 0.25 * yfrac;\n"
        "            weights[1] = xfrac1 + 0.25 * yfrac;\n"
        "        }\n"
        "\n"
        "///        weights[0] = (1. - xfrac1) * (1. - yfrac) + 0.25 * yfrac;\n"
        "///        weights[1] = xfrac1 * (1. - yfrac) + 0.25 * yfrac;\n"
        "        weights[2] = 0.25 * yfrac;\n"
        "        weights[3] = 0.25 * yfrac;\n"
        "    }\n"
        "///    weights[0] = 0.;\n"
        "///    weights[1] = 0.;\n"
        "///    weights[2] = 0.;\n"
        "///    weights[3] = 1.;\n"
        "    ring_indices[0] = ring1;\n"
        "    ring_indices[1] = ring2;\n"
        "    ring_indices[2] = ring3;\n"
        "    ring_indices[3] = ring4;\n"
        "\n"
        "    if (is_nest)\n"
        "        for (int m=0; m<4; ++m)\n"
        "            ring_indices[m] = ring2nest(order_, ring_indices[m]);\n"
        "\n"
        "}\n"
        "\n"
        "///void interpolate_weights_equirectangular(int order_, bool is_nest, int equi_width, int equi_height, const vec3 position, out ivec4 ring_indices, out dvec4 weights)\n"
        "void interpolate_weights_equirectangular(int order_, bool is_nest, const vec3 position, out ivec4 ring_indices, out dvec4 weights)\n"
        "{\n"
        "    int nside_  = int(1)<<order_;\n"
        "    int npface_ = nside_<<order_;\n"
        "    int ncap_   = (npface_-nside_)<<1;\n"
        "    int npix_   = 12*npface_;\n"
        "\n"
        "    double lat = atan(sqrt(position.x*position.x+position.y*position.y),position.z);\n"
        "    double lon = atan(position.y, position.x);    // The above commented line provides holes in north and south pole\n"
        "    if(lon<0.) lon += twopi;\n"
        "///    double z = position.z;\n"
        "\n"
        "    if((lat < 0.) || (lat > pi))  // normalize lat if needed\n"
        "    {\n"
        "      lat=fmodulo(lat,twopi);\n"
        "      if (lat>pi)\n"
        "      {\n"
        "        lon+=pi;\n"
        "        lat=twopi-lat;\n"
        "      }\n"
        "    }\n"
        "\n"
        "    if((lon < 0.) || (lon >= twopi))  // normalize lon if needed\n"
        "    {\n"
        "      lon=fmodulo(lon,twopi);\n"
        "    }\n"
        "\n"
        "    lat /= pi;\n"
        "    lon /= twopi;\n"
        "\n"
        "    ivec2 sizeTex=ivec2(equi_width, equi_height);\n"
        "    vec2 ptu = vec2(lon, lat) * sizeTex;\n"
        "\n"
        "    ptu = clamp(ptu - 0.5, vec2(0), vec2(sizeTex - 1));\n"
        "\n"
        "    vec2 ptui;\n"
        "    vec2 ptuf = modf(ptu, ptui);\n"
        "\n"
        "\n"
        "    ivec2 ptu00 = ivec2(ptui);\n"
        "    ivec2 ptu01 = ptu00 + ivec2(0, 1);\n"
        "    ivec2 ptu10 = ptu00 + ivec2(1, 0);\n"
        "    ivec2 ptu11 = ptu00 + ivec2(1, 1);\n"
        "\n"
        "    // Integer texel coordinates into the original texture.\n"
        "    ptu00 = clamp(ptu00 , ivec2(0), sizeTex - 1);\n"
        "    ptu01 = clamp(ptu01 , ivec2(0), sizeTex - 1);\n"
        "    ptu10 = clamp(ptu10 , ivec2(0), sizeTex - 1);\n"
        "    ptu11 = clamp(ptu11 , ivec2(0), sizeTex - 1);\n"
        "\n"
        "    float alpha = ptuf.x;\n"
        "    float beta = ptuf.y;\n"
        "    weights[0] = (1.-alpha) * (1.-beta);\n"
        "    weights[1] = (1.-alpha) * beta;\n"
        "    weights[2] = alpha * (1.-beta);\n"
        "    weights[3] = alpha * beta;\n"
        "\n"
        "    // convert back to longtitude and latitude\n"
        "    vec2 lonlat00 = vec2(ptu00) + 0.5;\n"
        "    vec2 lonlat01 = vec2(ptu01) + 0.5;\n"
        "    vec2 lonlat10 = vec2(ptu10) + 0.5;\n"
        "    vec2 lonlat11 = vec2(ptu11) + 0.5;\n"
        "\n"
        "    vec2 scale = vec2(twopi/double(equi_width), pi/double(equi_height));\n"
        "    lonlat00 *= scale;\n"
        "    lonlat01 *= scale;\n"
        "    lonlat10 *= scale;\n"
        "    lonlat11 *= scale;\n"
        "\n"
        "    ring_indices[0] = ang2pix(order_, is_nest, lonlat00.y, lonlat00.x);\n"
        "    ring_indices[1] = ang2pix(order_, is_nest, lonlat01.y, lonlat01.x);\n"
        "    ring_indices[2] = ang2pix(order_, is_nest, lonlat10.y, lonlat10.x);\n"
        "    ring_indices[3] = ang2pix(order_, is_nest, lonlat11.y, lonlat11.x);\n"
        "\n"
        "\n"
        "\n"
        "}\n"
        "\n"
        "void main()\n"
        "{\n"
        "\n"
        "    // planePoints are fragment points of a plane between zNear and zFar plane covering whole camera frustum.\n"
        "    // Since camera -Z direction always passes projection plane center,  each fragment world coordinate\n"
        "    // corresponds to a viewing ray. Since sphere has radius one, the normalized coordinate corresponds to\n"
        "    // the position/intersection on the unit sphere\n"
        "    vec3 spherepos_temp = normalize(planePoints);\n"
        "    vec3 spherepos = vec3(spherepos_temp.x, spherepos_temp.y, spherepos_temp.z);\n"
        "\n"
        "    int nSide = int(1)<<healpixOrder;\n"
        "    FragColor = vec4(0, 0, 0, 0);\n"
        "    vec2 pos;\n"
        "    int ix, iy, face_num;\n"
        "\n"
        "    ivec4 pixs;\n"
        "    dvec4 wgts;\n"
        "    double wtot = 0.;\n"
        "///    get_interpol(healpixOrder, isNest, spherepos, pixs, wgts);\n"
        "    interpolate_weights(healpixOrder, isNest, spherepos, pixs, wgts);\n"
        "///    interpolate_weights_equirectangular(healpixOrder, isNest, spherepos, pixs, wgts);\n"
        "\n"
        "    for (int i=0; i < 4; i++)\n"
        "    {\n"
        "        if (isNest)\n"
        "            nest2xyf(healpixOrder, pixs[i], ix, iy, face_num);\n"
        "        else\n"
        "            ring2xyf(healpixOrder, pixs[i], ix, iy, face_num);\n"
        "\n"
        "        FragColor += float(wgts[i]) * imageLoad(healpixFaceTexture, ivec3(ix, (nSide-1) - iy, face_num));\n"
        "        wtot += wgts[i];\n"
        "    }\n"
        "    FragColor  = FragColor / float(wtot);\n"
        "\n"
        "\n"
        "\n"
        "}\n"
        "";

const char *vertexShaderMesh =
"        #version 420 core                                                          \n"
"        layout (location = 0) in vec3 aPos;                                        \n"
"        layout (location = 1) in vec3 aNormal;                                     \n"
"        layout (location = 2) in vec2 aTexCoords;                                  \n"

"        out vec2 TexCoords;                                                        \n"

"        uniform mat4 model;                                                        \n"
"        uniform mat4 view;                                                         \n"
"        uniform mat4 projection;                                                   \n"

"        void main()                                                                \n"
"        {"
"            TexCoords = aTexCoords;                                                \n"
"            gl_Position = projection * view * model * vec4(aPos, 1.0);             \n"
"        }                                                                          \n";

const char *fragmentShaderMesh =
"        #version 420 core                                                                                                                  \n"
"        out vec4 FragColor;                                                                                                                \n"

"        in vec2 TexCoords;                                                                                                                 \n"
"        uniform sampler2D texture_diffuse;                                                                                                 \n"
"        layout(binding = 3, r8) writeonly uniform image2D maskImage;    // put 3 just to show that it can be any number                    \n"
"        uniform bool computeMask;                                                                                                          \n"
"        void main()                                                                                                                        \n"
"        {                                                                                                                                  \n"
"            if(computeMask)                                                                                                                \n"
"            {                                                                                                                              \n"
"                // When we use GL_LINEAR as filtering function and TEXTURE_WRAP is REPEAT. according to                                    \n"
"                // (page 150 of https://www.khronos.org/registry/OpenGL/specs/gl/glspec13.pdf), four                                       \n"
"                // nearest texels are used for sampling:                                                                                   \n"

"                // Floating point texel coordinate into the upscaled texture.                                                              \n"
"                ivec2 sizeTex_lev0 = textureSize(texture_diffuse, 0);                                                                      \n"
"                vec2 ptu = TexCoords * sizeTex_lev0;                                                                                       \n"
"                // Decompose ptu - 0.5 into the integer and fractional parts.                                                              \n"
"        ///        vec2 ptui;                                                                                                              \n"
"        ///        vec2 ptuf = modf(ptu - 0.5, ptui);                                                                                      \n"

"                // Integer texel coordinates into the upscaled texture.                                                                    \n"
"                ivec2 ptu00 = ivec2(ptu - 0.5);                                                                                            \n"
"                ivec2 ptu01 = ptu00 + ivec2(0, 1);                                                                                         \n"
"                ivec2 ptu10 = ptu00 + ivec2(1, 0);                                                                                         \n"
"                ivec2 ptu11 = ptu00 + ivec2(1, 1);                                                                                         \n"

"                // Integer texel coordinates into the original texture.                                                                    \n"
"                ivec2 pt00 = clamp(ptu00 , ivec2(0), sizeTex_lev0 - 1);                                                                    \n"
"                ivec2 pt01 = clamp(ptu01 , ivec2(0), sizeTex_lev0 - 1);                                                                    \n"
"                ivec2 pt10 = clamp(ptu10 , ivec2(0), sizeTex_lev0 - 1);                                                                    \n"
"                ivec2 pt11 = clamp(ptu11 , ivec2(0), sizeTex_lev0 - 1);                                                                    \n"

"                imageStore(maskImage, pt00, vec4(1.0, 0.0, 0.0, 0.0));                                                                     \n"
"                imageStore(maskImage, pt01, vec4(1.0, 0.0, 0.0, 0.0));                                                                     \n"
"                imageStore(maskImage, pt10, vec4(1.0, 0.0, 0.0, 0.0));                                                                     \n"
"                imageStore(maskImage, pt11, vec4(1.0, 0.0, 0.0, 0.0));                                                                     \n"
"            }                                                                                                                              \n"
"            FragColor = texture(texture_diffuse, TexCoords);                                                                               \n"
"        }                                                                                                                                  \n";

void OpenGLHandler::initGL() // it should be called only once (in the class constructor).
{
    int width = 5;  // fake width and height only because it is necessary as input argument to build opengl context. An expert in OpenGl can help to find a better way
    int height = 5;

    glfwInit();
    glfwDefaultWindowHints(); // optional, the current window hints are already the default
    glfwWindowHint(GLFW_VISIBLE, GL_FALSE); // the window will stay hidden after creation
    glfwWindowHint(GLFW_RESIZABLE, GL_TRUE); // the window will be resizable
    glfwWindowHint(GLFW_CONTEXT_VERSION_MAJOR, 4);
    glfwWindowHint(GLFW_CONTEXT_VERSION_MINOR, 2);
    glfwWindowHint(GLFW_OPENGL_PROFILE, GLFW_OPENGL_CORE_PROFILE);


    /* Create a window object. This window object holds all the windowing data and is used quite frequently by GLFW's other functions. */
    _window = glfwCreateWindow(width, height, "Show object", NULL, NULL);
    if (_window == NULL)
    {
        std::cerr << "Failed to create GLFW window" << std::endl;
        glfwTerminate();
        return;
    }
    /* Tell GLFW to make the context of our window the main context on the current thread. */
    glfwMakeContextCurrent(_window);

    if (!gladLoadGLLoader((GLADloadproc)glfwGetProcAddress))
    {
        std::cout << "Failed to initialize GLAD" << std::endl;
        return;
    }
//    glfwHideWindow(_window);

    _shader360 = NULL;
    _shader360 = new SHADER_PROGRAM();
    _shader360->addShaderSourceCode(SHADER_PROGRAM::SHADER_TYPE::VERTEX_SHADER, vertexShader360Video);
    _shader360->addShaderSourceCode(SHADER_PROGRAM::SHADER_TYPE::FARGMENT_SHADER, fragmentShader360Video);
    _shader360->link();

    _shader360_cubeMap = NULL;
    _shader360_cubeMap = new SHADER_PROGRAM();
    _shader360_cubeMap->addShaderSourceCode(SHADER_PROGRAM::SHADER_TYPE::VERTEX_SHADER, vertexShader360CubeMap);
    _shader360_cubeMap->addShaderSourceCode(SHADER_PROGRAM::SHADER_TYPE::FARGMENT_SHADER, fragmentShader360CubeMap);
    _shader360_cubeMap->link();


    _shader360_healpix = NULL;
    _shader360_healpix = new SHADER_PROGRAM();
    _shader360_healpix->addShaderSourceCode(SHADER_PROGRAM::SHADER_TYPE::VERTEX_SHADER, vertexShader360Video);  // the vertex shader is exactly same as version shader of 360 video
    _shader360_healpix->addShaderSourceCode(SHADER_PROGRAM::SHADER_TYPE::FARGMENT_SHADER, fragmentShader360Healpix);
//    _shader360_healpix->addShaderFile(SHADER_PROGRAM::SHADER_TYPE::FARGMENT_SHADER, "/home/nmahmoud/codes/c++/healpix/healpix/healpix_viewer.fs");
    _shader360_healpix->link();

//    _shaderMesh
    _shaderMesh = NULL;
    _shaderMesh = new SHADER_PROGRAM();
    _shaderMesh->addShaderSourceCode(SHADER_PROGRAM::SHADER_TYPE::VERTEX_SHADER, vertexShaderMesh);  // the vertex shader is exactly same as version shader of 360 video
    _shaderMesh->addShaderSourceCode(SHADER_PROGRAM::SHADER_TYPE::FARGMENT_SHADER, fragmentShaderMesh);
    _shaderMesh->link();
}






